#!/usr/bin/perl -w
#
######################################################################################
#
# MWA_DNS.pl (WebMonitor version 1.0)
#
# Usage: MWA_DNS.pl domainname [domainname2 ...domainnameN]
#
# N.B. domain names do not start with the www. prefix!
# 02/03/05
# Finds nameservers for a domain using the Net::DNS perl module
# Then quizes them for Resource Records using the dig command.
# You can adjust the timeouts as appropriate below.
#
# Copyright (C) 2005 MyWebAlert!
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
######################################################################################

use strict;
use warnings;
eval "use Net::DNS";
if ($@ ne "")
{
	print("MWA_DNS: couldn't load Net::DNS - $@\n");
	exit;
}

foreach my $domainname (@ARGV)
{
	print `date`;
	
	my $query = "";
	my $rr = "";
	my $resultstring = "Domain Name Server Tests for Domain:\t$domainname\n\n";
	my $digstart = 'dig +nocmd +nocomment +nostats +noquestion +noqr @';
	my $digend = ' www.'.$domainname;
	my $digstring = '';
	my $digresult = '';
	
	my $res = Net::DNS::Resolver->new;
	if (! defined ($res))
	{
		print("MWA_DNS: Net:DNS:Resolver is undefined\n");
		exit;
	}
	
	$res->tcp_timeout(10);
	$res->udp_timeout(10);
	$query = $res->query($domainname, "NS");
	
	if ($query)
	{
		foreach $rr (grep { $_->type eq 'NS' } $query->answer)
		{
			$digstring = $digstart.$rr->nsdname.$digend;
			$digresult = `$digstring 2>&1`;
			$resultstring = $resultstring."Name server: ".$rr->nsdname."\n\n".$digresult."\n";
		}
	}
	else
	{
		$resultstring = $resultstring."\tUnable to find nameserver: ".$res->errorstring."\n";
	}
	
	print("$resultstring");
	print `date`;
}




